Summary: Diagnostic Scan and Cluster Report Generator for Oracle VM and EL4/5/6
Name: vmpinfo
Version: 2.2
Release: 3
License: GPL2
Group: System
Vendor: Oracle Corporation
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Source0: %{name}-%{version}.tar.gz
Packager: Tom Lisjac <tom.lisjac@oracle.com>
BuildArch: noarch

%define basedir /usr
%define confdir /etc
%define installdir %{basedir}/bin
%define docdir %{basedir}/share/doc/%{name}-%{version}

Requires: bash >= 3.0, coreutils >= 4.5, grep >= 2.0

%description

VMPInfo is a cluster aware, diagnostic script that will run basic health
checks and gather detailed, addressable system information from an Oracle VM
Server, Manager or generic Enterprise Linux 4, 5 or 6 system. A single archive
is created that contains the scan data along with linking information that can
be merged with other host archives to produce a cluster oriented report. Html,
text, xml and sqlite3 database reports can be optionally generated to support
both manual and automated fault analysis. VMPInfo's fault detection architecture
is generalized and can be extended with plugins to provide test coverage for
additional products and platforms. 

%prep
%setup
%{__rm} -rf %{buildroot}
%{__mkdir} %{buildroot}
%{__mkdir} -p %{buildroot}%{installdir}
%{__mkdir} -p %{buildroot}%{confdir}
%{__mkdir} -p %{buildroot}%{docdir}

%install
install -p -m755 vmpinfo.sh $RPM_BUILD_ROOT%{installdir}
install -p -m644 vmpinfo.conf $RPM_BUILD_ROOT%{confdir}
install -p -m644 README-vmpinfo.txt $RPM_BUILD_ROOT%{docdir}
install -p -m644 MANUAL-vmpinfo.txt $RPM_BUILD_ROOT%{docdir}
install -p -m644 LICENSE $RPM_BUILD_ROOT%{docdir}

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%{installdir}/*
%{docdir}/*
%{confdir}/*

%pre
if [ "$1" = "1" ]; then
  for i in /etc/*-release; do
    if grep -q "Tikanga" $i; then exit 0; fi
    if grep -q "Oracle VM server release 2.2" $i; then exit 0; fi
    if grep -q "Oracle VM server release 3.0" $i; then exit 0; fi
    if grep -q "Nahant" $i; then exit 0; fi
    if grep -q "Carthage" $i; then exit 0; fi
    if grep -q "Santiago" $i; then exit 0; fi
    if grep -q "Fedora" $i; then exit 0; fi
  done
  echo "Sorry, VMPInfo is not supported on this OS version"
  exit 1
fi

%post
if [ "$1" = "1" ]; then
  [ -h %{installdir}/vmpinfo ] && rm -f %{installdir}/vmpinfo
  ln -s %{installdir}/vmpinfo.sh %{installdir}/vmpinfo
  echo
  echo "VMPInfo installation successful"
  echo "Run vmpinfo -m or see %{docdir} for instructions"
  echo
fi

%postun
if [ "$1" = "0" ]; then
  [ -h %{installdir}/vmpinfo ] && rm -f %{installdir}/vmpinfo
  rm -rf %{docdir}
  echo
  echo "VMPInfo has been successful removed"
  if [ -d /tmp/vmpinfo ]; then
    echo
    echo "The /tmp/vmpinfo directory exists and may contain report"
    echo "archives from previous scans that you may wish to remove."
  fi
  echo
fi

%changelog
* Sun May 22 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2-3
- Remove revision number from rpm spec filename generation (-Z)
- Fix html tag cosmetics with "< >" for ps and iscsiadm testops
- Add set selection for extended commands (-x) and v/r options
- Fix minor cosmetics and sequencing issues with clustersync (-C)
- Add man page for generating custom releases (-m 21)
- Patch man pages for correct ver-rev when they are generated (-P)
- Changed the /proc/meminfo testop to a clusterview key parameter
- Additional check for correct localhost formatting in /etc/hosts
- Limit scan for vm.cfg to ocfs2 partitions that are ovs repos

* Wed May 01 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2-2
- Add /proc "files" keyword and made it default for -K fs scan 
- Added "-p ^$$" to lsof to exclude vmpinfo files from listing 
- Add bash >= 3.0 and coreutils >= 4.5 to rpm spec dependencies
- Minor logic revision around syslog detail levels (-L)
- Fixes to manual pages and embedded rpm spec file
- Breakout ver/rev from rpm spec patching sed expressions (-Z)
- Add additional iscsi testops for node, session and stats
- Redir slotmap scan stdout to /dev/null for dm-mpath bound luns

* Mon Apr 25 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2-1
- Fix logic to re-enable manager scan, when role detected
- Change defaults to disable /proc and /sys scans and db report

* Sat Apr 16 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2
- GA release

* Tue Mar 22 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2RC4
- Add sqlite3 node db merg and sql export to merge.sh
- Selective /proc and /sys gathering (-K option)
- Improved archive error handling in merge.sh
- Reorganized report root directory for better clarity
- Verified sos capture on OL6 with updated sos rpm
- Added hang debugging using -d to known_issues man page
- Added plugin directory pointer (-V option)

* Wed Mar 17 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2RC3
- Add sqlite3 report emitter and command line option
- Small revision to internal vmpinfo state variables
- Update built-in manual pages

* Wed Mar 12 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2RC2
- Fixed xml emitter for consistent parsing by FF and DBs
- Added -f parameter to get vmpinfo.conf data from /path/fn
- Refactor and consolidate directory size code for dolinks
- Replace du with ls for fsize function... works on all os vers
- Add additional testops for /etc capture
- Add VM Manager XE or external db config capture
- Test on all supported platforms

* Fri Feb 25 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2RC1
- Fixed o2cb ping ambiguity when parsing cluster.conf 
- Fixed cosmetics with clustersync prompts
- Reduced font size from 18 to 14px. Cleaned up css

* Wed Feb 17 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2b9
- Added Network node test and related -N and -c switches
- Added checks for interface errors and half duplex
- Added no-write, restricted directories check
- Added event logging to syslog in detail levels 1..5
- Collected and dump all the vm.cfg's for an ovs box
- Changed netstat command line parm for better report
- Verified script wide local variable scoping
- Re-enabled and verified commented out ocfs2 checks
- Fixed and documented vmpinfo.conf sourcing
- Added premature exit trap to cleanup open sockets and files
- Ran all modes with bash -u: cleaned up a few unbound vars
- Added top level "data_dir" link for viewing raw report data
- Best practice check for nested ocfs2 and > 10 vm's on pub intf
- Fixed interface counter for dns lookup test labels
- Fixed scsi_id parameters if udev ver > 114 (for OL6)
- Revised script header docs with basic info and run procedure

* Mon Feb 07 2011 Tom Lisjac <tom.lisjac@oracle.com> 2.2b8
- Added Storage test with -S and related -B and -C switches
- Removed obsolete opstatus capture in FAE interface

